(*
   CS 31600
   Assignment 5
   Tests
*)

(* Global variables that make the interpreter output easier to read. *)
Control.Print.printDepth  := 20;
Control.Print.printLength := 30;



(* Exercise 2 Tests *)

member (1, []);
member (nil, nil);
member (0, [0]);
member (0, [1]);
member (1, [1, 3, 5, 7, 123]);
member (2, [1, 3, 5, 7, 123]);
member (123, [1, 3, 5, 7, 123]);
member (#"a", [#"c", #"a", #"n", #"t"]);
member (#"f", [#"c", #"a", #"n", #"t"]);


(* Exercise 3 Tests *)

less (5, [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]);
less (1, nil);
less (1, [1]);
less (9, [1, 2, 3]);
less (3, [7, 6, 4, 8, 1, 5, 2]);


(* Exercise 4 Tests *)

repeats nil;
repeats [1];
repeats [1, 1];
repeats [1, 2];
repeats [1, 2, 2];
repeats [1, 2, 3];
repeats [1, 2, 2, 3, 4];
repeats [1, 2, 3, 2, 4];
repeats [1, 1, 1, 1, 1];


(* Exercise 6' Tests *)

insert (0, nil);
insert (1, [2]);
insert (2, [1]);
insert (1, [2, 3]);
insert (2, [1, 3]);
insert (3, [1, 2]);
insert (3, [1, 2, 4, 5]);
insert (5, [1, 2, 3, 4]);
insert (4, [2, 5, 9, 10]);
insert (1, [1, 2, 3, 4]);
insert (3, [1, 2, 3, 4]);
insert (4, [1, 2, 3, 4]);


(* Exercise 6'' Tests *)

sort nil;
sort [1];
sort [10, 5];
sort [2, 1, 3];
sort [3, 2, 1];
sort [1, 1, 1, 2];
sort [1, 2, 3, 4, 5];
sort [4, 2, 6, 1, 8, 2, 3];


(* Exercise 7' Tests *)

(* Integers *)
sort2 (nil, icmp);
sort2 ([3], icmp);
sort2 ([2, 2, 1], icmp);
sort2 ([3, 2, 1, 4, 3, 8, 0], icmp);
sort2 ([3, 2, 1, 4, 3, 8, 0], ircmp);
sort2 ([1, 2, 3], icmp);
sort2 ([3, 2, 1], icmp);
sort2 ([1, 2, 3], ircmp);
sort2 ([3, 2, 1], ircmp);

(* Reals *)
sort2 (nil, rcmp);
sort2 ([3.1], rcmp);
sort2 ([3.1, 3.1, 1.5], rcmp);
sort2 ([3.1, 2.1, 1.5, 5.34, 5.5, 5.54, 3.11], rcmp);
sort2 ([3.1, 2.1, 1.5, 5.34, 5.5, 5.54, 3.11], rrcmp);
sort2 ([1.2, 5.6, 7.8], rcmp);
sort2 ([3.1, 2.1, 1.5], rcmp);

(* Characters *)
sort2 (nil, ccmp);
sort2 ([#"f"], ccmp);
sort2 ([#"f", #"f", #"z", #"e", #"u"], ccmp);
sort2 ([#"f", #"a", #"z", #"e", #"u", #"t"], ccmp);
sort2 ([#"f", #"a", #"z", #"e", #"u", #"t"], crcmp);
sort2 ([#"a", #"b", #"c", #"d", #"e"], ccmp);
sort2 ([#"f", #"a", #"z", #"e", #"u"], ccmp);

(* Integers *)
sortG (nil, icmp);
sortG ([3], icmp);
sortG ([2, 2, 1], icmp);
sortG ([3, 2, 1, 4, 3, 8, 0], icmp);
sortG ([3, 2, 1, 4, 3, 8, 0], ircmp);
sortG ([1, 2, 3], icmp);
sortG ([3, 2, 1], icmp);
sortG ([1, 2, 3], ircmp);
sortG ([3, 2, 1], ircmp);

(* Reals *)
sortG (nil, rcmp);
sortG ([3.1], rcmp);
sortG ([3.1, 3.1, 1.5], rcmp);
sortG ([3.1, 2.1, 1.5, 5.34, 5.5, 5.54, 3.11], rcmp);
sortG ([3.1, 2.1, 1.5, 5.34, 5.5, 5.54, 3.11], rrcmp);
sortG ([1.2, 5.6, 7.8], rcmp);
sortG ([3.1, 2.1, 1.5], rcmp);

(* Characters *)
sortG (nil, ccmp);
sortG ([#"f"], ccmp);
sortG ([#"f", #"f", #"z", #"e", #"u"], ccmp);
sortG ([#"f", #"a", #"z", #"e", #"u", #"t"], ccmp);
sortG ([#"f", #"a", #"z", #"e", #"u", #"t"], crcmp);
sortG ([#"a", #"b", #"c", #"d", #"e"], ccmp);
sortG ([#"f", #"a", #"z", #"e", #"u"], ccmp);


(* Exercise 8' Tests *)

twiddle nil; (* generates a "value restriction" error *)
twiddle [];  (* generates a "value restriction" error *)
twiddle [(1, 2, 3)];
twiddle [(5, 3, 2), (1, 1, 2)];
twiddle [(1, 2, 4), (1, 4, 6), (5, 3, 6)];


(* Exercise 9' Tests *)

flipper nil; (* generates a "value restriction" error *)
flipper [];  (* generates a "value restriction" error *)
flipper [1];
flipper [1, 2];
flipper [1, 4, 5];
flipper [1, 2, 3, 4, 5, 6, 7];
flipper [1, 2, 3, 4, 5, 6, 7, 8];